repos:
  - repo: https://github.com/pre-commit/pre-commit-hooks
    rev: v4.4.0
    hooks:
      - id: check-added-large-files
      - id: check-byte-order-marker
      - id: check-merge-conflict
      - id: check-toml
      - id: check-yaml
      - id: debug-statements
      - id: detect-private-key
      - id: double-quote-string-fixer
      - id: end-of-file-fixer
      - id: mixed-line-ending
      - id: trailing-whitespace
  - repo: https://github.com/pre-commit/pygrep-hooks
    rev: v1.10.0
    hooks:
      - id: python-no-eval
      - id: python-no-log-warn
      - id: python-use-type-annotations
  - repo: https://github.com/pre-commit/mirrors-autopep8
    rev: v2.0.1
    hooks:
      - id: autopep8
        args: [ '--max-line-length=140', '-i' ]
  - repo: https://github.com/pre-commit/mirrors-mypy
    rev: v1.0.0
    hooks:
      - id: mypy
        args: [ '--install-types', '--non-interactive', '--no-strict-optional', '--scripts-are-modules', '--ignore-missing-imports', '-i' ]
  - repo: https://github.com/PyCQA/pylint
    rev: v2.16.1
    hooks:
      - id: pylint
        exclude: ^setup.py|conf.py$
        args:
          - '--disable=too-few-public-methods' # Because it's not a good practice per se
          - '--disable=import-error' # Because pylint can be run from any environment, with or without all the deps
          - '--disable=no-member' # To avoid errors with the unitest mocking library that perform some magic
          - '--disable=missing-module-docstring' # Because we have a one file = one class policy. This rule would make comment duplicated.
          - '--max-line-length=140' # 140 is acceptable nowadays
          - '--max-attributes=10' # 10 is high, but acceptable in some situations
          - '--max-args=5' # 5 is already too high. Constructor may fail this rule but should be added as exception.
  - repo: https://github.com/PyCQA/bandit
    rev: 1.7.4
    hooks:
      - id: bandit
        files: 'src'
        args: ['-q', '-s', 'B404,B603']
